Index: sfd/FreeSerif.sfd
===================================================================
--- sfd/FreeSerif.sfd	(revision 4273)
+++ sfd/FreeSerif.sfd	(working copy)
@@ -262,7 +262,7 @@
 Lookup: 1 0 0 "'sups' superscript" { "'sups' superscript-oldstyle" ("superior") "'sups' superscript-numeric" ("superior") "'sups' superscript-fit" ("superior") "'sups' superscript-punct" ("superior") "'sups' superscript-phonetic" ("superior") "'sups' superscript-latin" ("superior") "'sups' superscript-Latin-D" ("superior") "'sups' superscript-currency" ("superior") } ['sups' ('cyrl' <'BGR ' 'BOS ' 'MKD ' 'SRB ' 'dflt' > 'grek' <'COP ' 'ELL ' 'PGR ' 'dflt' > 'gur2' <'dflt' > 'hano' <'dflt' > 'hebr' <'JII ' 'dflt' > 'latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' 'dflt' > ) ]
 Lookup: 2 0 0 "glyph decomp. of iogonek" { "Glyph Decomposition of iogonek-remove-dot"  } []
 Lookup: 1 0 0 "subst. i,j with dotless form" { "subst. i,j with dotless form-1"  } []
-Lookup: 6 0 0 "'ccmp' remove dot followed by mark in Latin" { "'ccmp' remove dot followed by mark in Latin 1"  } ['ccmp' ('latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' 'dflt' > ) ]
+Lookup: 6 0 0 "'ccmp' remove dot followed by mark in Latin"  {"'ccmp' remove dot followed by mark in Latin 1"  } ['ccmp' ('cyrl' <'ABK ' 'AZE ' 'BEL ' 'BGR ' 'BOS ' 'CHE ' 'CHK ' 'CHU ' 'CRT ' 'CSL ' 'EVK ' 'EVN ' 'ING ' 'KAB ' 'KAR ' 'KAZ ' 'KHA ' 'KHK ' 'KHS ' 'KHV ' 'KLM ' 'KOP ' 'KOZ ' 'KRK ' 'KRL ' 'MKD ' 'MNG ' 'MOL ' 'OSS ' 'RBU ' 'RSY ' 'RUS ' 'SRB ' 'TAJ ' 'TNE ' 'TUV ' 'UDM ' 'UKR ' 'UZB ' 'YAK ' 'dflt' > 'latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' 'dflt' > ) ]
 Lookup: 1 0 0 "'aalt' access-all-altern. in Latin" { "'aalt' access-all-alternates in Latin-1"  } ['aalt' ('latn' <'dflt' > 'latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' > ) ]
 Lookup: 1 0 0 "'cv01' char. var. in Latin for Cameroon" { "'cv01' char. var. in Latin for Cameroon-alpha"  } ['cv01' ('latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' 'dflt' > ) ]
 Lookup: 3 0 0 "'cv02' char. var. in Latin-ampersand" { "'cv02' char. var. in Latin-ampersand-1"  } ['cv02' ('latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' 'dflt' > ) ]
@@ -4867,7 +4867,7 @@
   FClassNames: "0"
 EndFPST
 ChainSub2: class "'ccmp' remove dot followed by mark in Latin 1" 2 1 3 2
-  Class: 16 i j ibar iogonek
+  Class: 25 i j ibar iogonek izhei jy
   FClass: 173 grave.cmb acute.cmb circumflex.cmb tilde.cmb macron.cmb breve.cmb dotaccent.cmb dieresis.cmb ring.cmb acutedbl.cmb hacek.cmb linevertabv.cmb linesvertdblabv.cmb gravedbl.cmb
   FClass: 201 harpoonleftabv.cmb harpoonrightabv.cmb rotateCCWabv.cmb rotateCWabv.cmb arrowleftabv.cmb arrowrightabv.cmb dotstripleabv.cmb dotsquadrupleabv.cmb arrowleftrightabv.cmb bridgewideabv.cmb asteriskabv.cmb
  1 0 1
@@ -22449,6 +22449,7 @@
 Fore
 Refer: 73 105 N 1 0 0 1 0 0 0
 Validated: 1
+Substitution2: "subst. i,j with dotless form-1" izhei.dotless
 Substitution2: "'smcp' lowercase to small caps in Cyrillic-1" sc.i
 EndChar
 
@@ -22477,6 +22478,7 @@
 Fore
 Refer: 74 106 N 1 0 0 1 0 0 0
 Validated: 1
+Substitution2: "subst. i,j with dotless form-1" jy.dotless
 Substitution2: "'smcp' lowercase to small caps in Cyrillic-1" sc.j
 EndChar
 
@@ -399168,5 +399170,32 @@
 EndSplineSet
 Validated: 1
 EndChar
+
+StartChar: izhei.dotless
+Encoding: 13476 -1 13476
+Width: 269
+VWidth: 0
+Flags: W
+AnchorPoint: "cyr-above" 128 472 basechar 0
+AnchorPoint: "cyr-below" 129 -14 basechar 0
+LayerCount: 2
+Fore
+Refer: 238 305 N 1 0 0 1 0 0 2
+Validated: 1
+EndChar
+
+StartChar: jy.dotless
+Encoding: 13477 -1 13477
+Width: 348
+VWidth: 0
+Flags: W
+AnchorPoint: "cyr-above" 210 472 basechar 0
+AnchorPoint: "cyr-below" 210 -200 basechar 0
+LayerCount: 2
+Fore
+Refer: 3546 567 N 1 0 0 1 0 0 2
+Validated: 1
+EndChar
+
 EndChars
 EndSplineFont
Index: sfd/FreeSerifBold.sfd
===================================================================
--- sfd/FreeSerifBold.sfd	(revision 4273)
+++ sfd/FreeSerifBold.sfd	(working copy)
@@ -223,7 +223,7 @@
 Lookup: 1 0 0 "'pnum' proportional figures in Sinhala" { "'pnum' proportional figures in Sinhala"  } ['pnum' ('sinh' <'dflt' > ) ]
 Lookup: 1 0 0 "'tnum' tabular figures in Sinhala" { "'tnum' tabular figures in Sinhala"  } ['lnum' ('sinh' <'dflt' > ) 'tnum' ('sinh' <'dflt' > ) ]
 Lookup: 2 0 0 "subst. i-ogonek with dotless-i+-ogonek" { "subst. i-ogonek with dotless-i+-ogonek"  } []
-Lookup: 6 0 0 "'ccmp' remove dot followed by mark in Latin" { "'ccmp' remove dot followed by mark in Latin"  } ['ccmp' ('latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' 'dflt' > ) ]
+Lookup: 6 0 0 "'ccmp' remove dot followed by mark in Latin"  {"'ccmp' remove dot followed by mark in Latin"  } ['ccmp' ('cyrl' <'ABK ' 'AZE ' 'BEL ' 'BGR ' 'BOS ' 'CHE ' 'CHK ' 'CHU ' 'CRT ' 'CSL ' 'EVK ' 'EVN ' 'ING ' 'KAB ' 'KAR ' 'KAZ ' 'KHA ' 'KHK ' 'KHS ' 'KHV ' 'KLM ' 'KOP ' 'KOZ ' 'KRK ' 'KRL ' 'MKD ' 'MNG ' 'MOL ' 'OSS ' 'RBU ' 'RSY ' 'RUS ' 'SRB ' 'TAJ ' 'TNE ' 'TUV ' 'UDM ' 'UKR ' 'UZB ' 'YAK ' 'dflt' > 'latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' 'dflt' > ) ]
 Lookup: 4 0 0 "'liga' std. ligatures in Latin for Dutch" { "'liga' std. ligatures in Latin for Dutch-1"  } ['liga' ('latn' <'NLD ' > ) ]
 Lookup: 1 0 0 "subst. i,j with dotless form" { "subst i,j with dotless form 1"  } []
 Lookup: 1 0 0 "'locl' localized forms in Latin for Sami" { "'locl' localized forms for Sami-1"  } ['locl' ('latn' <'ISM ' 'LSM ' 'NSM ' 'SKS ' > ) ]
@@ -3926,7 +3926,7 @@
   FClassNames: "0"
 EndFPST
 ChainSub2: class "'ccmp' remove dot followed by mark in Latin" 2 1 3 2
-  Class: 3 i j
+  Class: 14 i j icyr jecyr
   FClass: 186 grave.cmb acute.cmb circumflex.cmb tilde.cmb macron.cmb breve.cmb dotaccent.cmb dieresis.cmb ring.cmb acutedbl.cmb hacek.cmb linevertabv.cmb linesvertdblabv.cmb gravedbl.cmb breveinv.cmb
   FClass: 126 leftharpoonaccent rightharpoonaccent uni20D4 uni20D5 uni20D6 uni20D7 uni20DB uni20DC uni20E1 bridgewideabv.cmb asteriskabv.cmb
  1 0 1
@@ -19754,6 +19754,7 @@
 Fore
 Refer: 73 105 N 1 0 0 1 10 0 2
 Validated: 32769
+Substitution2: "subst i,j with dotless form 1" icyr.dotless
 Substitution2: "'smcp' lowercase to small caps in Cyrillic-1" sc.i
 EndChar
 
@@ -19781,6 +19782,7 @@
 Fore
 Refer: 74 106 N 1 0 0 1 0 0 3
 Validated: 32769
+Substitution2: "subst i,j with dotless form 1" jecyr.dotless
 Substitution2: "'smcp' lowercase to small caps in Cyrillic-1" sc.j
 EndChar
 
@@ -212091,5 +212093,32 @@
 EndSplineSet
 Validated: 1
 EndChar
+
+StartChar: icyr.dotless
+Encoding: 13476 -1 7654
+Width: 291
+VWidth: 0
+Flags: W
+AnchorPoint: "cyr-above" 142 470 basechar 0
+AnchorPoint: "cyr-below" 146 0 basechar 0
+LayerCount: 2
+Fore
+Refer: 238 305 N 1 0 0 1 0 0 2
+Validated: 1
+EndChar
+
+StartChar: jecyr.dotless
+Encoding: 13477 -1 7655
+Width: 384
+VWidth: 0
+Flags: W
+AnchorPoint: "cyr-above" 226 472 basechar 0
+AnchorPoint: "cyr-below" 204 -202 basechar 0
+LayerCount: 2
+Fore
+Refer: 2155 567 N 1 0 0 1 0 0 2
+Validated: 1
+EndChar
+
 EndChars
 EndSplineFont
Index: sfd/FreeSerifBoldItalic.sfd
===================================================================
--- sfd/FreeSerifBoldItalic.sfd	(revision 4273)
+++ sfd/FreeSerifBoldItalic.sfd	(working copy)
@@ -106,7 +106,7 @@
 Lookup: 4 0 0 "'liga' std. ligatures in Latin for Dutch" { "'liga' std. ligatures in Latin for Dutch"  } ['liga' ('latn' <'NLD ' > ) ]
 Lookup: 1 0 0 "'smcp' lowercase to small caps in Latin for Turkish" { "'smcp' lowercase to small caps in Latin for Turkish-1"  } ['smcp' ('latn' <'AZE ' 'CRT ' 'KAZ ' 'TAT ' 'TRK ' > ) ]
 Lookup: 6 0 0 "'ccmp' iogonek glyph decompos. in Latin" { "'ccmp' iogonek glyph decomp in Latin-1"  } ['ccmp' ('latn' <'dflt' > 'latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' > ) ]
-Lookup: 6 0 0 "'ccmp' remove dot followed by mark in Latin" { "'ccmp' remove dot followed by mark in Latin"  } ['ccmp' ('latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' 'dflt' > ) ]
+Lookup: 6 0 0 "'ccmp' remove dot followed by mark in Latin"  {"'ccmp' remove dot followed by mark in Latin"  } ['ccmp' ('cyrl' <'ABK ' 'AZE ' 'BEL ' 'BGR ' 'BOS ' 'CHE ' 'CHK ' 'CHU ' 'CRT ' 'CSL ' 'EVK ' 'EVN ' 'ING ' 'KAB ' 'KAR ' 'KAZ ' 'KHA ' 'KHK ' 'KHS ' 'KHV ' 'KLM ' 'KOP ' 'KOZ ' 'KRK ' 'KRL ' 'MKD ' 'MNG ' 'MOL ' 'OSS ' 'RBU ' 'RSY ' 'RUS ' 'SRB ' 'TAJ ' 'TNE ' 'TUV ' 'UDM ' 'UKR ' 'UZB ' 'YAK ' 'dflt' > 'latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' 'dflt' > ) ]
 Lookup: 4 0 0 "'ccmp' glyph compos. in Latin - i" { "'ccmp' glyph compos. in Latin - i-subtable"  } ['ccmp' ('latn' <'dflt' > 'latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' > ) ]
 Lookup: 2 0 0 "'smcp' small to small caps in Latin mult pre-decomp" { "'smcp' small to small caps in Latin mult pre-decomp-1"  "'smcp' small caps Roman Numerals-1"  } ['smcp' ('latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' 'dflt' > ) ]
 Lookup: 2 0 0 "'smcp' small caps in Latin pre-decompose" { "'smcp' small caps in Latin pre-decompose-basic"  "'smcp' small caps in Latin pre-decompose-A"  "'smcp' small caps in Latin pre-decompose-B"  "'smcp' small caps in Latin pre-decompose-B-2"  "'smcp' small caps in Latin pre-decompose-C"  "'smcp' small caps in Latin pre-decompose-additional"  "'smcp' small caps in Latin pre-decompose-additional-2"  "'smcp' small caps in Latin pre-decompose-viet"  } ['smcp' ('latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' 'dflt' > ) ]
@@ -844,7 +844,7 @@
   FClassNames: "0"
 EndFPST
 ChainSub2: class "'ccmp' remove dot followed by mark in Latin" 2 1 3 2
-  Class: 3 i j
+  Class: 14 i j icyr jecyr
   FClass: 172 grave.cmb acute.cmb circumflex.cmb tilde.cmb macron.cmb breve.cmb dieresis.cmb ring.cmb acutedbl.cmb hacek.cmb linevertabv.cmb linesvertdblabv.cmb gravedbl.cmb breveinv.cmb
   FClass: 126 leftharpoonaccent rightharpoonaccent uni20D4 uni20D5 uni20D6 uni20D7 uni20DB uni20DC uni20E1 bridgewideabv.cmb asteriskabv.cmb
  1 0 1
@@ -15626,6 +15626,7 @@
 Fore
 Refer: 73 105 N 1 0 0 1 0 0 3
 Validated: 1
+Substitution2: "subst i,j with dotless form 1" icyr.dotless
 Substitution2: "'smcp' lowercase to small caps in Cyrillic-1" sc.i
 EndChar
 
@@ -15651,6 +15652,7 @@
 Fore
 Refer: 74 106 N 1 0 0 1 0 0 3
 Validated: 1
+Substitution2: "subst i,j with dotless form 1" jecyr.dotless
 Substitution2: "'smcp' lowercase to small caps in Cyrillic-1" sc.j
 EndChar
 
@@ -91879,5 +91881,32 @@
 Validated: 1
 Substitution2: "'hist' historical forms in Cyrillic-jest" eiotifiedcyr
 EndChar
+
+StartChar: icyr.dotless
+Encoding: 13476 -1 3998
+Width: 292
+VWidth: 0
+Flags: W
+AnchorPoint: "cyr-above" 201 449 basechar 0
+AnchorPoint: "cyr-below" 111 0 basechar 0
+LayerCount: 2
+Fore
+Refer: 238 305 N 1 0 0 1 0 0 2
+Validated: 1
+EndChar
+
+StartChar: jecyr.dotless
+Encoding: 13477 -1 3999
+Width: 353
+VWidth: 0
+Flags: W
+AnchorPoint: "cyr-above" 271 481 basechar 0
+AnchorPoint: "cyr-below" 121 -201 basechar 0
+LayerCount: 2
+Fore
+Refer: 1587 567 N 1 0 0 1 0 0 2
+Validated: 1
+EndChar
+
 EndChars
 EndSplineFont
Index: sfd/FreeSerifItalic.sfd
===================================================================
--- sfd/FreeSerifItalic.sfd	(revision 4273)
+++ sfd/FreeSerifItalic.sfd	(working copy)
@@ -148,7 +148,7 @@
 Lookup: 4 0 0 "'liga' std. ligatures in Latin for Catalan" { "'liga' std. ligatures in Latin for Catalan-1"  } ['liga' ('latn' <'CAT ' > ) ]
 Lookup: 1 0 0 "'locl' local. forms in Latin for Sami" { "'locl' Localized Forms for Sami-1"  } ['locl' ('latn' <'ISM ' > 'latn' <'LSM ' > 'latn' <'NSM ' > 'latn' <'SKS ' > ) ]
 Lookup: 6 0 0 "'ccmp' iogonek glyph decompos. in Latin" { "'ccmp' iogonek glyph decomp in Latin-1"  } ['ccmp' ('latn' <'dflt' > 'latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' > ) ]
-Lookup: 6 0 0 "'ccmp' remove dot followed by mark in Latin" { "'ccmp' remove dot followed by mark in Latin"  } ['ccmp' ('latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' 'dflt' > ) ]
+Lookup: 6 0 0 "'ccmp' remove dot followed by mark in Latin"  {"'ccmp' remove dot followed by mark in Latin"  } ['ccmp' ('cyrl' <'ABK ' 'AZE ' 'BEL ' 'BGR ' 'BOS ' 'CHE ' 'CHK ' 'CHU ' 'CRT ' 'CSL ' 'EVK ' 'EVN ' 'ING ' 'KAB ' 'KAR ' 'KAZ ' 'KHA ' 'KHK ' 'KHS ' 'KHV ' 'KLM ' 'KOP ' 'KOZ ' 'KRK ' 'KRL ' 'MKD ' 'MNG ' 'MOL ' 'OSS ' 'RBU ' 'RSY ' 'RUS ' 'SRB ' 'TAJ ' 'TNE ' 'TUV ' 'UDM ' 'UKR ' 'UZB ' 'YAK ' 'dflt' > 'latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' 'dflt' > ) ]
 Lookup: 4 0 0 "'ccmp' glyph compos. in Latin - i" { "'ccmp' glyph compos. in Latin - i-subtable"  } ['ccmp' ('latn' <'dflt' > 'latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' > ) ]
 Lookup: 2 0 0 "'ccmp' saraam decomp. for Thai" { "'ccmp' saraam decomp. for Thai-1"  } ['ccmp' ('thai' <'dflt' > ) ]
 Lookup: 4 0 0 "'rlig' rqd. ligatures in Thai" { "'rlig' rqd. ligatures in Thai 0"  } ['rlig' ('thai' <'dflt' > ) ]
@@ -1129,7 +1129,7 @@
   FClassNames: "0"
 EndFPST
 ChainSub2: class "'ccmp' remove dot followed by mark in Latin" 2 1 3 2
-  Class: 3 i j
+  Class: 14 i j icyr jecyr
   FClass: 172 grave.cmb acute.cmb circumflex.cmb tilde.cmb macron.cmb breve.cmb dieresis.cmb ring.cmb acutedbl.cmb hacek.cmb linevertabv.cmb linesvertdblabv.cmb gravedbl.cmb breveinv.cmb
   FClass: 108 leftharpoonaccent rightharpoonaccent uni20D4 uni20D5 uni20D6 uni20D7 uni20DB uni20DC uni20E1 uni20E9 uni20F0
  1 0 1
@@ -16058,6 +16058,7 @@
 Fore
 Refer: 73 105 N 1 0 0 1 0 0 3
 Validated: 1
+Substitution2: "subst i,j with dotless form 1" icyr.dotless
 Substitution2: "'smcp' lowercase to small caps in Cyrillic-1" sc.i
 EndChar
 
@@ -16083,6 +16084,7 @@
 Fore
 Refer: 74 106 N 1 0 0 1 0 0 3
 Validated: 1
+Substitution2: "subst i,j with dotless form 1" jecyr.dotless
 Substitution2: "'smcp' lowercase to small caps in Cyrillic-1" sc.j
 EndChar
 
@@ -129041,5 +129043,32 @@
 Validated: 1
 Substitution2: "'hist' historical forms in Cyrillic-jest" eiotifiedcyr
 EndChar
+
+StartChar: icyr.dotless
+Encoding: 13476 -1 5103
+Width: 246
+VWidth: 0
+Flags: W
+AnchorPoint: "cyr-above" 189 472 basechar 0
+AnchorPoint: "cyr-below" 95 -14 basechar 0
+LayerCount: 2
+Fore
+Refer: 238 305 N 1 0 0 1 0 0 2
+Validated: 1
+EndChar
+
+StartChar: jecyr.dotless
+Encoding: 13477 -1 5104
+Width: 300
+VWidth: 0
+Flags: W
+AnchorPoint: "cyr-above" 255 472 basechar 0
+AnchorPoint: "cyr-below" 70 -200 basechar 0
+LayerCount: 2
+Fore
+Refer: 1647 567 N 1 0 0 1 0 0 2
+Validated: 1
+EndChar
+
 EndChars
 EndSplineFont