commit b24925dfc5e936927885aba536fd552fe5f4ee69
Author: Phil Krylov <phil@krylov.eu>
Date:   Sun Apr 30 22:04:41 2023 +0200

    rlig: Cyrillic psili with acute or grave

diff --git a/sfd/FreeSerif.sfd b/sfd/FreeSerif.sfd
index 17df0d69..fcbb7376 100644
--- a/sfd/FreeSerif.sfd
+++ b/sfd/FreeSerif.sfd
@@ -296,6 +296,7 @@ Lookup: 1 0 0 "'hist' hist. forms in Latin" { "'hist' hist. forms in Latin-1"  }
 Lookup: 4 0 0 "'hlig' hist. ligatures in Latin" { "'hlig' hist. ligatures in Latin-1"  } ['hlig' ('latn' <'dflt' > 'latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' > ) ]
 Lookup: 4 0 0 "'hlig' hist. ligatures in Latin for German" { "'hlig' hist. ligatures in Latin for German-1"  } ['hlig' ('latn' <'DEU ' > ) ]
 Lookup: 1 0 0 "'locl' localized forms for Sami" { "'locl' localized forms for Sami-1"  } ['locl' ('latn' <'ISM ' > 'latn' <'LSM ' > 'latn' <'NSM ' > 'latn' <'SKS ' > ) ]
+Lookup: 4 0 0 "'rlig' req. mark ligatures in Cyrillic" { "'rlig' req. mark ligatures in Cyrillic-1"  } ['rlig' ('cyrl' <'ABK ' 'AZE ' 'BEL ' 'BGR ' 'BOS ' 'CHE ' 'CHK ' 'CHU ' 'CRT ' 'CSL ' 'EVK ' 'EVN ' 'ING ' 'KAB ' 'KAR ' 'KAZ ' 'KHA ' 'KHK ' 'KHS ' 'KHV ' 'KLM ' 'KOP ' 'KOZ ' 'KRK ' 'KRL ' 'MKD ' 'MNG ' 'MOL ' 'OSS ' 'RBU ' 'RSY ' 'RUS ' 'SRB ' 'TAJ ' 'TNE ' 'TUV ' 'UDM ' 'UKR ' 'UZB ' 'YAK ' 'dflt' > ) ]
 Lookup: 4 0 0 "'liga' std. ligatures in Cyrillic" { "'liga' std. ligatures in Cyrillic-1"  } ['liga' ('cyrl' <'dflt' > 'cyrl' <'BGR ' 'BOS ' 'MKD ' 'SRB ' > ) ]
 Lookup: 2 0 0 "'c2sc' caps to small caps in Cyrillic pre-decompose" { "'c2sc' caps to small caps in Cyrillic pre-decompose-1"  } ['c2sc' ('cyrl' <'BGR ' 'BOS ' 'MKD ' 'SRB ' 'dflt' > ) ]
 Lookup: 1 0 0 "'c2sc' caps to small caps in Cyrillic" { "'c2sc' caps to small caps in Cyrillic-invar-ext-B"  "'c2sc' caps to small caps in Cyrillic-1"  "'c2sc' caps to small caps in Cyrillic-B"  "'c2sc' caps to small caps in Cyrillic-ext-B"  "'c2sc' caps to small caps in Cyrillic-suppl"  "'c2sc' caps to small caps in Cyrillic-invariant"  "'c2sc' caps to small caps in Cyrillic-invariant-B"  "'c2sc' caps to small caps in Cyrillic-invar-suppl"  } ['c2sc' ('cyrl' <'BGR ' 'BOS ' 'MKD ' 'SRB ' 'dflt' > ) ]
@@ -399244,5 +399245,38 @@ SplineSet
  231 223 l 1
 EndSplineSet
 EndChar
+
+StartChar: uniE001
+Encoding: 57345 57345 13479
+Width: 0
+VWidth: 0
+GlyphClass: 4
+Flags: W
+AnchorPoint: "cyr-stacking" -178 458.5 mark 0
+AnchorPoint: "cyr-stacking" -174 732 basemark 0
+AnchorPoint: "cyr-above" -181 460 mark 0
+LayerCount: 2
+Fore
+Refer: 2080 8142 N 1 0 0 1 -333 0 2
+Validated: 1
+Ligature2: "'rlig' req. mark ligatures in Cyrillic-1" zvateltso.cmb acute.cmb
+EndChar
+
+StartChar: uniE003
+Encoding: 57347 57347 13480
+Width: 0
+VWidth: 0
+GlyphClass: 4
+Flags: W
+AnchorPoint: "cyr-stacking" -157 733 basemark 0
+AnchorPoint: "cyr-stacking" -161 459.5 mark 0
+AnchorPoint: "cyr-above" -159 460 mark 0
+LayerCount: 2
+Fore
+Refer: 2079 8141 N 1 0 0 1 -335 0 2
+Validated: 1
+Ligature2: "'rlig' req. mark ligatures in Cyrillic-1" zvateltso.cmb grave.cmb
+EndChar
+
 EndChars
 EndSplineFont
diff --git a/sfd/FreeSerifBold.sfd b/sfd/FreeSerifBold.sfd
index db06375a..f64c650a 100644
--- a/sfd/FreeSerifBold.sfd
+++ b/sfd/FreeSerifBold.sfd
@@ -309,6 +309,7 @@ Lookup: 2 0 0 "'c2sc' caps to small caps in Cyrillic pre-decompose" { "'c2sc' ca
 Lookup: 1 0 0 "'c2sc' caps to small caps in Cyrillic" { "'c2sc' caps to small caps in Cyrillic-1"  "'c2sc' caps to small caps in Cyrillic-B"  "'c2sc' caps to small caps in Cyrillic-invariant"  "'c2sc' caps to small caps in Cyrillic-invariant-B"  "'c2sc' caps to small caps in Cyrillic-invar-ext-B"  } ['c2sc' ('cyrl' <'BGR ' 'BOS ' 'MKD ' 'SRB ' 'dflt' > ) ]
 Lookup: 2 0 0 "'smcp' small caps in Cyrillic pre-decompose" { "'smcp' small caps in Cyrillic pre-decompose-1"  } ['smcp' ('cyrl' <'BGR ' 'BOS ' 'MKD ' 'SRB ' 'dflt' > ) ]
 Lookup: 1 0 0 "'smcp' lowercase to small caps in Cyrillic" { "'smcp' lowercase to small caps in Cyrillic-1"  "'smcp' lowercase to small caps in Cyrillic-B"  } ['smcp' ('cyrl' <'BGR ' 'BOS ' 'MKD ' 'SRB ' 'dflt' > ) ]
+Lookup: 4 0 0 "'rlig' req. mark ligatures in Cyrillic" { "'rlig' req. mark ligatures in Cyrillic-1"  } ['rlig' ('cyrl' <'ABK ' 'AZE ' 'BEL ' 'BGR ' 'BOS ' 'CHE ' 'CHK ' 'CHU ' 'CRT ' 'CSL ' 'EVK ' 'EVN ' 'ING ' 'KAB ' 'KAR ' 'KAZ ' 'KHA ' 'KHK ' 'KHS ' 'KHV ' 'KLM ' 'KOP ' 'KOZ ' 'KRK ' 'KRL ' 'MKD ' 'MNG ' 'MOL ' 'OSS ' 'RBU ' 'RSY ' 'RUS ' 'SRB ' 'TAJ ' 'TNE ' 'TUV ' 'UDM ' 'UKR ' 'UZB ' 'YAK ' 'dflt' > ) ]
 Lookup: 4 0 1 "'liga' std. ligatures in Cyrillic" { "'liga' std. ligatures in Cyrillic-1"  } ['liga' ('cyrl' <'BGR ' 'BOS ' 'MKD ' 'SRB ' 'dflt' > ) ]
 Lookup: 1 0 0 "'ss01' style set 1 in Cyrillic for Bulgarian" { "'ss01' style set 1 in Cyrillic for Bulgarian-1"  } ['ss01' ('cyrl' <'BGR ' > ) ]
 Lookup: 1 0 0 "'locl' local. forms in Cyrillic for South Slavic" { "'locl' local. forms in Cyrillic for South Slavic-1"  } ['locl' ('cyrl' <'BOS ' 'MKD ' 'SRB ' > ) ]
@@ -212164,5 +212165,38 @@ SplineSet
  201 399 264 255 282 213 c 1
 EndSplineSet
 EndChar
+
+StartChar: uniE001
+Encoding: 57345 57345 7657
+Width: 0
+VWidth: 0
+GlyphClass: 4
+Flags: W
+AnchorPoint: "cyr-stacking" -178 458.5 mark 0
+AnchorPoint: "cyr-stacking" -174 732 basemark 0
+AnchorPoint: "cyr-above" -181 460 mark 0
+LayerCount: 2
+Fore
+Refer: 1156 8142 N 1 0 0 1 -333 0 2
+Validated: 1
+Ligature2: "'rlig' req. mark ligatures in Cyrillic-1" psilipneumatacyr.cmb acute.cmb
+EndChar
+
+StartChar: uniE003
+Encoding: 57347 57347 7658
+Width: 0
+VWidth: 0
+GlyphClass: 4
+Flags: W
+AnchorPoint: "cyr-stacking" -157 733 basemark 0
+AnchorPoint: "cyr-stacking" -161 459.5 mark 0
+AnchorPoint: "cyr-above" -159 460 mark 0
+LayerCount: 2
+Fore
+Refer: 1155 8141 N 1 0 0 1 -335 0 2
+Validated: 1
+Ligature2: "'rlig' req. mark ligatures in Cyrillic-1" psilipneumatacyr.cmb grave.cmb
+EndChar
+
 EndChars
 EndSplineFont
diff --git a/sfd/FreeSerifBoldItalic.sfd b/sfd/FreeSerifBoldItalic.sfd
index 77d16586..543e33e5 100644
--- a/sfd/FreeSerifBoldItalic.sfd
+++ b/sfd/FreeSerifBoldItalic.sfd
@@ -142,6 +142,7 @@ Lookup: 1 0 0 "'smcp' lowercase to small caps in Cyrillic" { "'smcp' lowercase t
 Lookup: 1 0 0 "'ss01' style set 1 in Cyrillic for Bulgarian" { "'ss01' style set 1 in Cyrillic for Bulgarian-1"  } ['ss01' ('cyrl' <'BGR ' > ) ]
 Lookup: 1 0 0 "'locl' local. forms in Cyrillic for South Slavic" { "'locl' local. forms in Cyrillic for South Slavic"  } ['locl' ('cyrl' <'BOS ' 'MKD ' 'SRB ' > ) ]
 Lookup: 1 0 0 "'cv01' char. variant in Cyrillic for South Slavic" { "'cv01' char. variant in Cyrillic for South Slavic-1"  } ['cv01' ('cyrl' <'BOS ' 'MKD ' 'SRB ' > ) ]
+Lookup: 4 0 0 "'rlig' req. mark ligatures in Cyrillic" { "'rlig' req. mark ligatures in Cyrillic-1"  } ['rlig' ('cyrl' <'ABK ' 'AZE ' 'BEL ' 'BGR ' 'BOS ' 'CHE ' 'CHK ' 'CHU ' 'CRT ' 'CSL ' 'EVK ' 'EVN ' 'ING ' 'KAB ' 'KAR ' 'KAZ ' 'KHA ' 'KHK ' 'KHS ' 'KHV ' 'KLM ' 'KOP ' 'KOZ ' 'KRK ' 'KRL ' 'MKD ' 'MNG ' 'MOL ' 'OSS ' 'RBU ' 'RSY ' 'RUS ' 'SRB ' 'TAJ ' 'TNE ' 'TUV ' 'UDM ' 'UKR ' 'UZB ' 'YAK ' 'dflt' > ) ]
 Lookup: 4 0 0 "'liga' std. ligatures in Cyrillic" { "'liga' std. ligatures in Cyrillic 1"  } ['liga' ('cyrl' <'dflt' > 'cyrl' <'BGR ' 'BOS ' 'MKD ' 'SRB ' > ) ]
 Lookup: 1 0 0 "'locl' old local forms in Cyrillic for South Slavic" { "'locl' old local forms in South Cyrillic"  } ['locl' ('cyrl' <'BGR ' 'BOS ' 'MKD ' 'SRB ' > ) ]
 Lookup: 1 0 0 "'hist' historical forms in Cyrillic" { "'hist' historical forms in Cyrillic-jest"  } ['hist' ('cyrl' <'dflt' > 'cyrl' <'BGR ' 'BOS ' 'MKD ' 'SRB ' > ) ]
@@ -91946,5 +91947,38 @@ SplineSet
  485 372 459 348 429 348 c 0
 EndSplineSet
 EndChar
+
+StartChar: uniE001
+Encoding: 57345 57345 4001
+Width: 0
+VWidth: 0
+GlyphClass: 4
+Flags: W
+AnchorPoint: "cyr-stacking" -178 458.5 mark 0
+AnchorPoint: "cyr-stacking" -174 732 basemark 0
+AnchorPoint: "cyr-above" -181 460 mark 0
+LayerCount: 2
+Fore
+Refer: 1134 8142 N 1 0 0 1 -333 0 2
+Validated: 1
+Ligature2: "'rlig' req. mark ligatures in Cyrillic-1" psilipneumatacyr.cmb acute.cmb
+EndChar
+
+StartChar: uniE003
+Encoding: 57347 57347 4002
+Width: 0
+VWidth: 0
+GlyphClass: 4
+Flags: W
+AnchorPoint: "cyr-stacking" -157 733 basemark 0
+AnchorPoint: "cyr-stacking" -161 459.5 mark 0
+AnchorPoint: "cyr-above" -159 460 mark 0
+LayerCount: 2
+Fore
+Refer: 1133 8141 N 1 0 0 1 -335 0 2
+Validated: 1
+Ligature2: "'rlig' req. mark ligatures in Cyrillic-1" psilipneumatacyr.cmb grave.cmb
+EndChar
+
 EndChars
 EndSplineFont
diff --git a/sfd/FreeSerifItalic.sfd b/sfd/FreeSerifItalic.sfd
index fe07ecdd..2d03db4d 100644
--- a/sfd/FreeSerifItalic.sfd
+++ b/sfd/FreeSerifItalic.sfd
@@ -124,6 +124,7 @@ Lookup: 1 0 0 "'locl' local. forms in Cyrillic for South Slavic" { "'locl' local
 Lookup: 1 0 0 "'locl' old local forms in Cyrillic for South Slavic" { "'locl' old local forms in South Cyrillic"  } ['locl' ('cyrl' <'BGR ' 'BOS ' 'MKD ' 'SRB ' > ) ]
 Lookup: 1 0 0 "'hist' historical forms in Cyrillic" { "'hist' historical forms in Cyrillic-jest"  } ['hist' ('cyrl' <'dflt' > 'cyrl' <'BGR ' 'BOS ' 'MKD ' 'SRB ' > ) ]
 Lookup: 1 0 0 "'cv01' char. variant in Cyrillic for South Slavic" { "'cv01' char. variant in Cyrillic for South Slavic-1"  } ['cv01' ('cyrl' <'BOS ' 'MKD ' 'SRB ' > ) ]
+Lookup: 4 0 0 "'rlig' req. mark ligatures in Cyrillic" { "'rlig' req. mark ligatures in Cyrillic-1"  } ['rlig' ('cyrl' <'ABK ' 'AZE ' 'BEL ' 'BGR ' 'BOS ' 'CHE ' 'CHK ' 'CHU ' 'CRT ' 'CSL ' 'EVK ' 'EVN ' 'ING ' 'KAB ' 'KAR ' 'KAZ ' 'KHA ' 'KHK ' 'KHS ' 'KHV ' 'KLM ' 'KOP ' 'KOZ ' 'KRK ' 'KRL ' 'MKD ' 'MNG ' 'MOL ' 'OSS ' 'RBU ' 'RSY ' 'RUS ' 'SRB ' 'TAJ ' 'TNE ' 'TUV ' 'UDM ' 'UKR ' 'UZB ' 'YAK ' 'dflt' > ) ]
 Lookup: 4 0 0 "'liga' std. ligatures in Cyrillic" { "'liga' std. ligatures in Cyrillic 0"  } ['liga' ('cyrl' <'dflt' > 'cyrl' <'BGR ' 'BOS ' 'MKD ' 'SRB ' > ) ]
 Lookup: 4 0 1 "'liga' std. ligatures in Latin for Dutch" { "'liga' std. ligatures in Latin for Dutch"  } ['liga' ('latn' <'NLD ' > ) ]
 Lookup: 2 0 0 "'ccmp' glyph decomp. in Latin-stacked accents" { "'ccmp' glyph decomp. in Latin-B"  "'ccmp' glyph decomp. in Latin-Ext-Addl"  } ['ccmp' ('latn' <'AZE ' 'CAT ' 'CRT ' 'DEU ' 'ESP ' 'ISM ' 'KAZ ' 'LSM ' 'NLD ' 'NSM ' 'SKS ' 'TAT ' 'TRK ' 'VIT ' 'dflt' > ) ]
@@ -129110,5 +129111,38 @@ SplineSet
  267 -133 276 -146 291 -146 c 0
 EndSplineSet
 EndChar
+
+StartChar: uniE001
+Encoding: 57345 57345 5106
+Width: 0
+VWidth: 0
+GlyphClass: 4
+Flags: W
+AnchorPoint: "cyr-stacking" -178 458.5 mark 0
+AnchorPoint: "cyr-stacking" -174 732 basemark 0
+AnchorPoint: "cyr-above" -181 460 mark 0
+LayerCount: 2
+Fore
+Refer: 1233 8142 N 1 0 0 1 -333 0 2
+Validated: 1
+Ligature2: "'rlig' req. mark ligatures in Cyrillic-1" psilipneumatacyr.cmb acute.cmb
+EndChar
+
+StartChar: uniE003
+Encoding: 57347 57347 5107
+Width: 0
+VWidth: 0
+GlyphClass: 4
+Flags: W
+AnchorPoint: "cyr-stacking" -157 733 basemark 0
+AnchorPoint: "cyr-stacking" -161 459.5 mark 0
+AnchorPoint: "cyr-above" -159 460 mark 0
+LayerCount: 2
+Fore
+Refer: 1371 8141 N 1 0 0 1 -335 0 2
+Validated: 1
+Ligature2: "'rlig' req. mark ligatures in Cyrillic-1" psilipneumatacyr.cmb grave.cmb
+EndChar
+
 EndChars
 EndSplineFont